import pdb

def compute_agreement_all_relations():
	opiec_lines = open("dsa_OPIEC_sample_labels.txt", "r").readlines()
	openie5_lines = open("dsa_OpenIE5_filtered.txt", "r").readlines()
	rnnoie_lines = open("dsa_rnn_oie_filtered.txt", "r").readlines()
	stanford_lines = open("dsa_stanford_oie_filtered.txt", "r").readlines()

	opiec_labels = {}
	for line in opiec_lines:
		if "#" in line:
			line_split = line.split("\t")
			opiec_labels[line_split[0]] = line_split[2][0]
	
	openie5_labels = {}
	label = "#000"
	for line in openie5_lines:
		line_split = line.split("\t")
		if "#" in line:
			label = line_split[0]
			openie5_labels[label] = "UNDEFINED"
		if len(line_split) == 3:
			openie5_labels[label] = line_split[2][0]

	rnnoie_labels = {}
	label = "#000"
	for line in rnnoie_lines:
		line_split = line.split("\t")
		if len(line_split) >= 3:
			if "#" in line:
				label = line_split[0]
				rnnoie_labels[label] = "UNDEFINED"
			else:
				rnnoie_labels[label] = line_split[-1][0]

	stanford_labels = {}
	label = "#000"
	count = 0
	for line in stanford_lines:
		line_split = line.split("\t")
		if "#" in line:
			label = line_split[0]
			stanford_labels[label] = "UNDEFINED"
			count += 1
		elif len(line_split) >= 3:
			stanford_labels[label] = line_split[-1][0]
	
	
	openie5_stats = get_label_agree_stats(opiec_labels, openie5_labels, "openie5")
	rnnoie_stats = get_label_agree_stats(opiec_labels, rnnoie_labels, "RnnOIE")
	stanford_stats = get_label_agree_stats(opiec_labels, stanford_labels, "Stanford")
	all_stats = {}
	all_stats['lbl_agree'] = openie5_stats['lbl_agree'] + rnnoie_stats['lbl_agree'] + stanford_stats['lbl_agree']
	all_stats['lbl_disagree'] = openie5_stats['lbl_disagree'] + rnnoie_stats['lbl_disagree'] + stanford_stats['lbl_disagree']
	all_stats['disagreeing'] = openie5_stats['disagreeing'] + rnnoie_stats['disagreeing'] + stanford_stats['disagreeing']
	all_stats['disag_opiec->oie'] = openie5_stats['disag_opiec->oie'] + rnnoie_stats['disag_opiec->oie'] + stanford_stats['disag_opiec->oie']
	
	print("\nAgreement of ALL labels: " + str(all_stats['lbl_agree']/(all_stats['lbl_agree']+all_stats['lbl_disagree'])))
	print(all_stats)
	
	print("\nAgreement of OpenIE 5 labels: " + str(openie5_stats['lbl_agree']/(openie5_stats['lbl_agree']+openie5_stats['lbl_disagree'])))
	print(openie5_stats)

	print("\nAgreement of RnnOIE labels: " + str(rnnoie_stats['lbl_agree']/(rnnoie_stats['lbl_agree']+rnnoie_stats['lbl_disagree'])))
	print(rnnoie_stats)

	print("\nAgreement of Stanford OIE labels: " + str(stanford_stats['lbl_agree']/(stanford_stats['lbl_agree']+stanford_stats['lbl_disagree'])))
	print(stanford_stats)
	print("\n")
	
	pdb.set_trace()

def get_label_agree_stats(opiec_labels, openie_labels, openie_system):
	openie_stats = {}
	openie_stats['lbl_agree'] = 0
	openie_stats['lbl_disagree'] = 0
	openie_stats['disagreeing'] = []
	openie_stats['disag_opiec->oie'] = []
	for key in opiec_labels:
		if openie_labels[key] != "/":
			if openie_labels[key] == opiec_labels[key]:
				openie_stats['lbl_agree'] += 1
			else:
				#if openie_system == "Stanford":
				#	pdb.set_trace()
				openie_stats['lbl_disagree'] += 1
				openie_stats['disagreeing'].append(key + "-" + openie_system + ":opiec_label=" + opiec_labels[key] + "; " + openie_system + "_label=" + openie_labels[key])
				openie_stats['disag_opiec->oie'].append(opiec_labels[key] + "->" + openie_labels[key])
	return openie_stats

def main():
	compute_agreement_all_relations()

if __name__ == '__main__':
	main()